package com.fs.erp.service.impl;

import com.fs.erp.constant.OrderStatusEnum;
import com.fs.erp.domain.ErpOrder;
import com.fs.erp.domain.ErpOrderItem;
import com.fs.erp.domain.ErpOrderPayment;
import com.fs.erp.domain.ErpRefundOrder;
import com.fs.erp.dto.*;
import com.fs.erp.http.JstErpHttpService;
import com.fs.erp.service.IErpOrderService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class JSTErpOrderServiceImpl implements IErpOrderService {
    @Autowired
    private JstErpHttpService jstErpHttpService;
    @Override
    public ErpOrderResponse addOrder(ErpOrder order) {
        ErpOrderPayment erpOrderPayment = order.getPayments().get(0);

        ShopOrderDTO shopOrderDTO = new ShopOrderDTO();
        shopOrderDTO.setShopId(Long.valueOf(order.getShop_code()));
        shopOrderDTO.setSoId(order.getPlatform_code());
        shopOrderDTO.setOrderDate(order.getDeal_datetime());
        // 待发货
        shopOrderDTO.setShopStatus(OrderStatusEnum.WAIT_SELLER_SEND_GOODS.name());
        // 买家账号
        shopOrderDTO.setShopBuyerId(order.getReceiver_phone());
        // 收货人省份
        shopOrderDTO.setReceiverState(order.getReceiver_province());
        // 收货人城市
        shopOrderDTO.setReceiverCity(order.getReceiver_city());
        // 收货人区域
        shopOrderDTO.setReceiverDistrict(order.getReceiver_district());
        // 收货人详细地址
        shopOrderDTO.setReceiverAddress(order.getReceiver_address());
        // 收货人详细地址
        shopOrderDTO.setReceiverName(order.getReceiver_name());
        // 收货人电话
        shopOrderDTO.setReceiverPhone(order.getReceiver_phone());
        // 支付金额
        shopOrderDTO.setPayAmount(erpOrderPayment.getPayment());
        // 运费
        shopOrderDTO.setFreight(order.getPost_fee());
        // 备注
        shopOrderDTO.setRemark(order.getBuyer_memo());
        // 买家留言
        shopOrderDTO.setBuyerMessage(order.getBuyer_memo());
        // 物流ID
        shopOrderDTO.setLId(order.getExpress_code());

        // 订单商品项列表
        List<ErpOrderItem> details = order.getDetails();
        List<OrderItemDTO> itemDTOList = new ArrayList<>();
        for (ErpOrderItem detail : details) {
            OrderItemDTO orderItemDTO = new OrderItemDTO();
            orderItemDTO.setSkuId(detail.getItem_code());
            orderItemDTO.setShopSkuId(detail.getSku_code());
            orderItemDTO.setAmount(Double.valueOf(detail.getPrice()));
            orderItemDTO.setBasePrice(Double.valueOf(detail.getOrigin_price()));
            orderItemDTO.setQty(detail.getQty());
            orderItemDTO.setOuterOiId(detail.getItem_code());
            itemDTOList.add(orderItemDTO);
        }
        shopOrderDTO.setItems(itemDTOList);


        PaymentDTO paymentDTO = new PaymentDTO();
        paymentDTO.setAmount(erpOrderPayment.getPayment());
        paymentDTO.setOuterPayId(order.getPlatform_code());
        paymentDTO.setPayDate(order.getDeal_datetime());
        paymentDTO.setPayment("微信");
        paymentDTO.setBuyerAccount(order.getReceiver_phone());
        paymentDTO.setSellerAccount("平台销售");
        shopOrderDTO.setPay(paymentDTO);

        jstErpHttpService.upload(shopOrderDTO);

        ErpOrderResponse erpOrderResponse = new ErpOrderResponse();
        erpOrderResponse.setSuccess(true);
        return erpOrderResponse;
    }

    @Override
    public ErpOrderResponse refundOrder(ErpRefundOrder order) {
        return null;
    }

    @Override
    public ErpDeliverysResponse getDeliver(ErpDeliverysRequest param) {
        return null;
    }

    @Override
    public ErpOrderQueryResponse getOrder(ErpOrderQueryRequert param) {
        return null;
    }

    @Override
    public BaseResponse refundUpdate(ErpRefundUpdateRequest param) {
        return null;
    }
}
